Public Class Form1

#Region " Private Felder "
    ' Liste mit ausgewhlten Pfaden
    Private m_SelectedPfade As New List(Of String)
#End Region

#Region " Properties "

#End Region

#Region " Konstruktor "

    Public Sub New()

        ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Fgen Sie Initialisierungen nach dem InitializeComponent()-Aufruf hinzu.

        ' Sortier-ComboBox fllen
        For I As Integer = 0 To 2
            Me.ToolStripComboBoxSortierung.Items.Add(CType(I, ThumbSortierTypen))
        Next
        ' For die ComboBoxen SelectedIndex auf 0 stellen
        Me.ToolStripComboBoxSortierung.SelectedIndex = 0
        Me.ToolStripComboBoxGroesse.SelectedIndex = 0

        ' Der DirectoryToolStripDropDownButton liefert in jedem Fall einen Pfad zu einem
        ' SpecialFolder. Dieser Pfad wird dem TreeView als TopDirectoryPath bergeben
        Me.FolderTreeView1.TopDirectoryPath = Me.DirectoryToolStripDropDownButton1.SelectedPath

    End Sub

#End Region

#Region " Methoden "

    ''' <summary>
    ''' Handler fr das SelectedPath_Changed-Event des FolderTreeView
    ''' </summary>
    Private Sub FolderTreeView1_SelectedPath_Changed() Handles FolderTreeView1.SelectedPath_Changed
        ' Eigentlich wre hier nur notwendig, diesen Pfad an das ThumbControl-Steuerelement
        ' weiter zu geben. Aber ich will Selected Items speichern, 
        ' also wird's etwas mehr Code
        Dim Path As String = FolderTreeView1.SelectedPath
        Dim AllePfade As New List(Of ThumbPath)
        Dim SelectedPfade As New List(Of ThumbPath)

        AllePfade.AddRange(Me.ThumbControl1.Pfade)
        SelectedPfade.AddRange(Me.ThumbControl1.SelectedPfade)

        For Each Pfad As ThumbPath In AllePfade
            If Not SelectedPfade.Contains(Pfad) Then
                If m_SelectedPfade.Contains(Pfad.ToString) Then
                    m_SelectedPfade.Remove(Pfad.ToString)
                End If
            End If
        Next
        For Each Pfad As ThumbPath In SelectedPfade
            If Not m_SelectedPfade.Contains(Pfad.ToString) Then
                m_SelectedPfade.Add(Pfad.ToString)
            End If
        Next

        ' Eigentlich ist nur dies erforderlich, um ein neues Directory anzuzeigen
        Me.ThumbControl1.Path = Path

        AllePfade.Clear()
        SelectedPfade.Clear()
        AllePfade.AddRange(Me.ThumbControl1.Pfade)
        For Each Pfad As ThumbPath In AllePfade
            If m_SelectedPfade.Contains(Pfad.ToString) Then
                SelectedPfade.Add(Pfad)
            End If
        Next
        Me.ThumbControl1.SelectedPfade = SelectedPfade.ToArray

    End Sub

    ''' <summary>
    ''' ndert die Thumbnail-Breite im ThumbControl abhngig von nderungen in der ToolStripComboBox
    ''' </summary>
    Private Sub SetImageWidth()
        Try
            Dim NewWidth As Integer = CInt(ToolStripComboBoxGroesse.Text)
            Me.ThumbControl1.ImageWidth = NewWidth
            Me.ToolStripComboBoxGroesse.Text = NewWidth
        Catch ex As Exception

        End Try
    End Sub

    ''' <summary>
    ''' Handler fr das SelectedIndexChanged-Event des ToolStripComboBoxGroesse
    ''' </summary>
    Private Sub ToolStripComboBoxGroesse_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles ToolStripComboBoxGroesse.SelectedIndexChanged
        SetImageWidth()
    End Sub
    ''' <summary>
    ''' Handler fr das Validating-Event des ToolStripComboBoxGroesse
    ''' </summary>
    Private Sub ToolStripComboBoxGroesse_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles ToolStripComboBoxGroesse.Validating
        SetImageWidth()
    End Sub
    ''' <summary>
    ''' Handler fr das SelectedIndexChanged-Event des ToolStripComboBoxSortierung
    ''' </summary>
    Private Sub ToolStripComboBoxSortierung_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles ToolStripComboBoxSortierung.SelectedIndexChanged
        Me.ThumbControl1.Sortierung = ToolStripComboBoxSortierung.SelectedItem
    End Sub
    ''' <summary>
    ''' Handler fr das SelectedPath_Changed-Event des DirectoryToolStripDropDownButton
    ''' </summary>
    Private Sub DirectoryToolStripDropDownButton1_SelectedPath_Changed() Handles DirectoryToolStripDropDownButton1.SelectedPath_Changed
        Me.FolderTreeView1.TopDirectoryPath = Me.DirectoryToolStripDropDownButton1.SelectedPath
    End Sub

#End Region

End Class
